diff --git a/job.cpp b/job.cpp
index 0b7c146..c877310 100644
--- a/job.cpp
+++ b/job.cpp
@@ -11,47 +11,41 @@
 
 #include "pgAgent.h"
 
-#include <wx/file.h>
-#include <wx/filefn.h>
-#include <wx/filename.h>
-#include <wx/process.h>
-
 #include <sys/types.h>
 
-#ifndef __WIN32__
+#if !BOOST_OS_WINDOWS
 #include <errno.h>
 #include <sys/wait.h>
+#include <sys/stat.h>
 #endif
 
-Job::Job(DBconn *conn, const wxString &jid)
+Job::Job(DBconn *conn, const std::wstring &jid)
 {
 	threadConn = conn;
 	jobid = jid;
-	status = wxT("");
+	status = L"";
 
-	LogMessage(wxString::Format(_("Starting job: %s"), jobid.c_str()), LOG_DEBUG);
+	LogMessage((L"Starting job: " + jobid), LOG_DEBUG);
 
 	int rc = threadConn->ExecuteVoid(
-	             wxT("UPDATE pgagent.pga_job SET jobagentid=") + backendPid + wxT(", joblastrun=now() ")
-	             wxT(" WHERE jobagentid IS NULL AND jobid=") + jobid);
+		L"UPDATE pgagent.pga_job SET jobagentid=" + backendPid + L", joblastrun=now() " +
+		L" WHERE jobagentid IS NULL AND jobid=" + jobid);
 
 	if (rc == 1)
 	{
-		DBresult *id = threadConn->Execute(
-		                   wxT("SELECT nextval('pgagent.pga_joblog_jlgid_seq') AS id"));
+		DBresultPtr id = threadConn->Execute(
+			L"SELECT nextval('pgagent.pga_joblog_jlgid_seq') AS id");
 		if (id)
 		{
-			logid = id->GetString(wxT("id"));
+			logid = id->GetString(L"id");
 
-			DBresult *res = threadConn->Execute(
-			                    wxT("INSERT INTO pgagent.pga_joblog(jlgid, jlgjobid, jlgstatus) ")
-			                    wxT("VALUES (") + logid + wxT(", ") + jobid + wxT(", 'r')"));
+			DBresultPtr res = threadConn->Execute(
+				L"INSERT INTO pgagent.pga_joblog(jlgid, jlgjobid, jlgstatus) "
+				L"VALUES (" + logid + L", " + jobid + L", 'r')");
 			if (res)
 			{
-				status = wxT("r");
-				delete res;
+				status = L"r";
 			}
-			delete id;
 		}
 	}
 }
@@ -59,21 +53,21 @@ Job::Job(DBconn *conn, const wxString &jid)
 
 Job::~Job()
 {
-	if (status != wxT(""))
+	if (status != L"")
 	{
 		threadConn->ExecuteVoid(
-		    wxT("UPDATE pgagent.pga_joblog ")
-		    wxT("   SET jlgstatus='") + status + wxT("', jlgduration=now() - jlgstart ")
-		    wxT(" WHERE jlgid=") + logid + wxT(";\n")
-
-		    wxT("UPDATE pgagent.pga_job ")
-		    wxT("   SET jobagentid=NULL, jobnextrun=NULL ")
-		    wxT(" WHERE jobid=") + jobid
-		);
+			L"UPDATE pgagent.pga_joblog "
+			L"   SET jlgstatus='" + status + L"', jlgduration=now() - jlgstart " +
+			L" WHERE jlgid=" + logid + L";\n" +
+
+			L"UPDATE pgagent.pga_job " +
+			L"   SET jobagentid=NULL, jobnextrun=NULL " +
+			L" WHERE jobid=" + jobid
+			);
 	}
 	threadConn->Return();
 
-	LogMessage(wxString::Format(_("Completed job: %s"), jobid.c_str()), LOG_DEBUG);
+	LogMessage((L"Completed job: " + jobid), LOG_DEBUG);
 }
 
 
@@ -81,71 +75,69 @@ int Job::Execute()
 {
 	int rc = 0;
 	bool succeeded = false;
-	DBresult *steps = threadConn->Execute(
-	                      wxT("SELECT * ")
-	                      wxT("  FROM pgagent.pga_jobstep ")
-	                      wxT(" WHERE jstenabled ")
-	                      wxT("   AND jstjobid=") + jobid +
-	                      wxT(" ORDER BY jstname, jstid"));
+	DBresultPtr steps = threadConn->Execute(
+		L"SELECT * "
+		L"  FROM pgagent.pga_jobstep "
+		L" WHERE jstenabled "
+		L"   AND jstjobid=" + jobid +
+		L" ORDER BY jstname, jstid");
 
 	if (!steps)
 	{
-		status = wxT("i");
+		status = L"i";
 		return -1;
 	}
 
 	while (steps->HasData())
 	{
 		DBconn *stepConn;
-		wxString jslid, stepid, jpecode, output;
+		std::wstring jslid, stepid, jpecode, output;
 
-		stepid = steps->GetString(wxT("jstid"));
+		stepid = steps->GetString(L"jstid");
 
-		DBresult *id = threadConn->Execute(
-		                   wxT("SELECT nextval('pgagent.pga_jobsteplog_jslid_seq') AS id"));
+		DBresultPtr id = threadConn->Execute(
+			L"SELECT nextval('pgagent.pga_jobsteplog_jslid_seq') AS id");
 		if (id)
 		{
-			jslid = id->GetString(wxT("id"));
-			DBresult *res = threadConn->Execute(
-			                    wxT("INSERT INTO pgagent.pga_jobsteplog(jslid, jsljlgid, jsljstid, jslstatus) ")
-			                    wxT("SELECT ") + jslid + wxT(", ") + logid + wxT(", ") + stepid + wxT(", 'r'")
-			                    wxT("  FROM pgagent.pga_jobstep WHERE jstid=") + stepid);
+			jslid = id->GetString(L"id");
+			DBresultPtr res = threadConn->Execute(
+				L"INSERT INTO pgagent.pga_jobsteplog(jslid, jsljlgid, jsljstid, jslstatus) "
+				L"SELECT " + jslid + L", " + logid + L", " + stepid + L", 'r'" +
+				L"  FROM pgagent.pga_jobstep WHERE jstid=" + stepid);
 
 			if (res)
 			{
 				rc = res->RowsAffected();
-				delete res;
 			}
 			else
 				rc = -1;
 		}
-		delete id;
 
 		if (rc != 1)
 		{
-			status = wxT("i");
+			status = L"i";
 			return -1;
 		}
 
-		switch ((int) steps->GetString(wxT("jstkind"))[0])
+		switch ((int)steps->GetString(L"jstkind")[0])
 		{
 			case 's':
 			{
-				wxString jstdbname = steps->GetString(wxT("jstdbname"));
-				wxString jstconnstr = steps->GetString(wxT("jstconnstr"));
+				std::wstring jstdbname = steps->GetString(L"jstdbname");
+				std::wstring jstconnstr = steps->GetString(L"jstconnstr");
 
 				stepConn = DBconn::Get(jstconnstr, jstdbname);
 				if (stepConn)
 				{
-					LogMessage(wxString::Format(_("Executing SQL step %s (part of job %s)"), stepid.c_str(), jobid.c_str()), LOG_DEBUG);
-					rc = stepConn->ExecuteVoid(steps->GetString(wxT("jstcode")));
+					LogMessage((L"Executing SQL step " + stepid + L"(part of job " + jobid + L")"), LOG_DEBUG);
+					rc = stepConn->ExecuteVoid(steps->GetString(L"jstcode"));
 					succeeded = stepConn->LastCommandOk();
 					output = stepConn->GetLastError();
 					stepConn->Return();
 				}
 				else
 				{
-					output = _("Couldn't get a connection to the database!");
+					output = L"Couldn't get a connection to the database!";
 					succeeded = false;
 				}
 
@@ -155,104 +147,104 @@ int Job::Execute()
 			case 'b':
 			{
 				// Batch jobs are more complex thank SQL, for obvious reasons...
-				LogMessage(wxString::Format(_("Executing batch step %s (part of job %s)"), stepid.c_str(), jobid.c_str()), LOG_DEBUG);
+				LogMessage((L"Executing batch step" + stepid + L"(part of job " + jobid + L")"), LOG_DEBUG);
 
 				// Get a temporary filename, then reuse it to create an empty directory.
-				wxString dirname = wxFileName::CreateTempFileName(wxT("pga_"));
-				if (dirname.Length() == 0)
-				{
-					output = _("Couldn't get a temporary filename!");
-					LogMessage(_("Couldn't get a temporary filename!"), LOG_WARNING);
-					rc = -1;
-					break;
-				}
+                                std::wstring wTmpDir = getTemporaryDirectoryPath();
+				std::string sDirectory(wTmpDir.begin(), wTmpDir.end());
+				std::string sFilesName = "";
+				std::string prefix = "pga_";
+				int last_n_char = 7;
+
+                                // Genrate random string of 6 characters long to make unique dir name
+                                std::string result = generateRandomString(7);
+				sFilesName = prefix + result;
+#if BOOST_OS_WINDOWS
+				std::string sModel = (boost::format("%s\\%s") % sDirectory % sFilesName).str();
+#else
+				std::string sModel = (boost::format("%s/%s") % sDirectory % sFilesName).str();
+#endif
+				std::string dir_name = sModel;
+				std::wstring dirname(dir_name.begin(), dir_name.end());
 
-				;
-				if (!wxRemoveFile(dirname))
+				if (dirname == L"")
 				{
-					output.Printf(_("Couldn't remove temporary file: %s"), dirname.c_str());
+					output = L"Couldn't get a temporary filename!";
 					LogMessage(output, LOG_WARNING);
 					rc = -1;
 					break;
 				}
 
-				if (!wxMkdir(dirname, 0700))
+				if (!boost::filesystem::create_directory(boost::filesystem::path(dir_name)))
 				{
-					output.Printf(_("Couldn't create temporary directory: %s"), dirname.c_str());
-					LogMessage(output, LOG_WARNING);
+					LogMessage((L"Couldn't create temporary directory: " + dirname), LOG_WARNING);
 					rc = -1;
 					break;
 				}
 
-#ifdef __WIN32__
-				wxString filename = dirname + wxT("\\") + jobid + wxT("_") + stepid + wxT(".bat");
-				wxString errorFile = dirname + wxT("\\") + jobid + wxT("_") + stepid + wxT("_error.txt");
+#if BOOST_OS_WINDOWS
+				std::wstring filename = dirname + L"\\" + jobid + L"_" + stepid + L".bat";
+				std::wstring errorFile = dirname + L"\\" + jobid + L"_" + stepid + L"_error.txt";
 #else
-				wxString filename = dirname + wxT("/") + jobid + wxT("_") + stepid + wxT(".scr");
-				wxString errorFile = dirname + wxT("/") + jobid + wxT("_") + stepid + wxT("_error.txt");
+				std::wstring filename = dirname + L"/" + jobid + L"_" + stepid + L".scr";
+				std::wstring errorFile = dirname + L"/" + jobid + L"_" + stepid + L"_error.txt";
 #endif
 
-				// Write the script
-				wxFile *file = new wxFile();
-
-				if (!file->Create(filename, true, wxS_IRUSR | wxS_IWUSR | wxS_IXUSR))
-				{
-					output.Printf(_("Couldn't create temporary script file: %s"), filename.c_str());
-					LogMessage(output, LOG_WARNING);
-					rc = -1;
-					break;
-				}
-
-				if (!file->Open(filename, wxFile::write))
-				{
-					output.Printf(_("Couldn't open temporary script file: %s"), filename.c_str());
-					LogMessage(output, LOG_WARNING);
-					wxRemoveFile(filename);
-					wxRmdir(dirname);
-					rc = -1;
-					break;
-				}
-
-				wxString code = steps->GetString(wxT("jstcode"));
+				std::wstring code = steps->GetString(L"jstcode");
 
 				// Cleanup the code. If we're on Windows, we need to make all line ends \r\n,
 				// If we're on Unix, we need \n
-				code.Replace(wxT("\r\n"), wxT("\n"));
-#ifdef __WIN32__
-				code.Replace(wxT("\n"), wxT("\r\n"));
+				boost::replace_all(code, "\r\n", "\n");
+#if BOOST_OS_WINDOWS
+				boost::replace_all(code, "\n", "\r\n");
 #endif
+				std::ofstream out_file;
+				std::string s_code(code.begin(), code.end());
+				std::string sfilename(filename.begin(), filename.end());
+				std::string serrorFile(errorFile.begin(), errorFile.end());
 
-				if (!file->Write(code))
+				out_file.open((const char *)sfilename.c_str(), std::ios::out);
+				if (out_file.fail())
 				{
-					output.Printf(_("Couldn't write to temporary script file: %s"), filename.c_str());
-					LogMessage(output, LOG_WARNING);
-					wxRemoveFile(filename);
-					wxRmdir(dirname);
+					LogMessage((L"Couldn't open temporary script file: " + filename), LOG_WARNING);
+					if (boost::filesystem::exists(dirname))
+						boost::filesystem::remove_all(dirname);
 					rc = -1;
 					break;
 				}
+				else
+				{
+					out_file << s_code;
+					out_file.close();
+#if !BOOST_OS_WINDOWS
+					// change file permission to 700 for executable in linux
+					int ret = chmod((const char *)sfilename.c_str(), S_IRWXU);
+					if (ret != 0)
+						LogMessage((L"Error setting executable permission to file: " + filename), LOG_DEBUG);
+#endif
+				}
 
-				file->Close();
-				LogMessage(wxString::Format(_("Executing script file: %s"), filename.c_str()), LOG_DEBUG);
+				LogMessage((L"Executing script file: " + filename), LOG_DEBUG);
 
 				// freopen function is used to redirect output of stream (stderr in our case)
 				// into the specified file.
-				FILE *fpError = freopen(errorFile.mb_str(), "w", stderr);
+				FILE *fpError = freopen((const char *)serrorFile.c_str(), "w", stderr);
 
 				// Execute the file and capture the output
-#ifdef __WIN32__
+#if BOOST_OS_WINDOWS
 				// The Windows way
 				HANDLE h_script, h_process;
 				DWORD dwRead;
 				char chBuf[4098];
 
-				h_script = win32_popen_r(filename.wc_str(), h_process);
+				h_script = win32_popen_r(filename.c_str(), h_process);
 				if (!h_script)
 				{
-					output.Printf(_("Couldn't execute script: %s, GetLastError() returned %d, errno = %d"), filename.c_str(), GetLastError(), errno);
-					LogMessage(output, LOG_WARNING);
+					LogMessage((boost::wformat(L"Couldn't execute script: %s, GetLastError() returned %s, errno = %d") % filename.c_str() % GetLastError() % errno).str(), LOG_WARNING);
 					CloseHandle(h_process);
 					rc = -1;
+					if (fpError)
+						fclose(fpError);
 					break;
 				}
 
@@ -262,11 +254,11 @@ int Job::Execute()
 				{
 					for (;;)
 					{
-						if(!ReadFile(h_script, chBuf, 4096, &dwRead, NULL) || dwRead == 0)
+						if (!ReadFile(h_script, chBuf, 4096, &dwRead, NULL) || dwRead == 0)
 							break;
 
 						chBuf[dwRead] = 0;
-						output += wxString::FromAscii(chBuf);
+						output += CharToWString((const char *)chBuf);
 					}
 				}
 
@@ -280,12 +272,13 @@ int Job::Execute()
 				FILE *fp_script;
 				char buf[4098];
 
-				fp_script = popen(filename.mb_str(wxConvUTF8), "r");
+				fp_script = popen((const char *)sfilename.c_str(), "r");
 				if (!fp_script)
 				{
-					output.Printf(_("Couldn't execute script: %s, errno = %d"), filename.c_str(), errno);
-					LogMessage(output, LOG_WARNING);
+					LogMessage((boost::wformat(L"Couldn't execute script: %s, errno = %d") % filename.c_str() % errno).str(), LOG_WARNING);
 					rc = -1;
+					if(fpError)
+						fclose(fpError);
 					break;
 				}
 
@@ -293,7 +286,7 @@ int Job::Execute()
 				while(!feof(fp_script))
 				{
 					if (fgets(buf, 4096, fp_script) != NULL)
-						output += wxString::FromAscii(buf);
+						output += CharToWString((const char *)buf);
 				}
 
 				rc = pclose(fp_script);
@@ -306,50 +299,46 @@ int Job::Execute()
 #endif
 
 				// set success status for batch runs, be pessimistic by default
-				LogMessage(wxString::Format(_("Script return code: %d"), rc), LOG_DEBUG);
+				LogMessage((boost::wformat(L"Script return code: %d") % rc).str(), LOG_DEBUG);
 				succeeded = ((rc == 0) ? true : false);
 				// If output is empty then either script did not return any output
 				// or script threw some error into stderr.
 				// Check script threw some error into stderr
 				if (fpError)
 				{
-					//fclose(fpError);
-					FILE* fpErr = fopen(errorFile.mb_str(), "r");
+					fclose(fpError);
+					FILE* fpErr = fopen((const char *)serrorFile.c_str(), "r");
 					if (fpErr)
 					{
 						char buffer[4098];
-						wxString errorMsg = wxEmptyString;
+						std::wstring errorMsg = L"";
 						while (!feof(fpErr))
 						{
 							if (fgets(buffer, 4096, fpErr) != NULL)
-								errorMsg += wxString(buffer, wxConvLibc);
+								errorMsg += CharToWString(buffer);
 						}
 
-						if (errorMsg != wxEmptyString) {
-							wxString errmsg =
-								wxString::Format(
-										_("Script Error: \n%s\n"),
-										errorMsg.c_str());
-							LogMessage(errmsg, LOG_WARNING);
-							output += wxT("\n") + errmsg;
+						if (errorMsg != L"") {
+							std::wstring errmsg = L"Script Error: \n" + errorMsg + L"\n",
+								LogMessage((L"Script Error: \n" + errorMsg + L"\n"), LOG_WARNING);
+							output += L"\n" + errmsg;
 						}
 
 						fclose(fpErr);
 					}
-					wxRemoveFile(errorFile);
 				}
 
 				// Delete the file/directory. If we fail, don't overwrite the script output in the log, just throw warnings.
-				if (!wxRemoveFile(filename))
+				try
 				{
-					LogMessage(wxString::Format(_("Couldn't remove temporary script file: %s"), filename.c_str()), LOG_WARNING);
-					wxRmdir(dirname);
-					break;
+					boost::filesystem::path dir_path(dir_name);
+					if (boost::filesystem::exists(dir_path))
+						boost::filesystem::remove_all(dir_path);
 				}
-
-				if (!wxRmdir(dirname))
+				catch (boost::filesystem::filesystem_error const & e)
 				{
-					LogMessage(wxString::Format(_("Couldn't remove temporary directory: "), dirname.c_str()), LOG_WARNING);
+					//display error message
+					LogMessage(CharToWString((const char *)e.what()), LOG_WARNING);
 					break;
 				}
 
@@ -357,71 +346,76 @@ int Job::Execute()
 			}
 			default:
 			{
-				output = _("Invalid step type!");
-				status = wxT("i");
+				output = L"Invalid step type!";
+				status = L"i";
 				return -1;
 			}
 		}
 
-		wxString stepstatus;
+		std::wstring stepstatus;
 		if (succeeded)
-			stepstatus = wxT("s");
+			stepstatus = L"s";
 		else
-			stepstatus = steps->GetString(wxT("jstonerror"));
+			stepstatus = steps->GetString(L"jstonerror");
 
 		rc = threadConn->ExecuteVoid(
-		         wxT("UPDATE pgagent.pga_jobsteplog ")
-		         wxT("   SET jslduration = now() - jslstart, ")
-		         wxT("       jslresult = ") + NumToStr(rc) + wxT(", jslstatus = '") + stepstatus + wxT("', ")
-		         wxT("       jsloutput = ") + threadConn->qtDbString(output) + wxT(" ")
-		         wxT(" WHERE jslid=") + jslid);
-		if (rc != 1 || stepstatus == wxT("f"))
+			L"UPDATE pgagent.pga_jobsteplog "
+			L"   SET jslduration = now() - jslstart, "
+			L"       jslresult = " + NumToStr(rc) + L", jslstatus = '" + stepstatus + L"', " +
+			L"       jsloutput = " + threadConn->qtDbString(output) + L" " +
+			L" WHERE jslid=" + jslid);
+		if (rc != 1 || stepstatus == L"f")
 		{
-			status = wxT("f");
+			status = L"f";
 			return -1;
 		}
 		steps->MoveNext();
 	}
-	delete steps;
 
-	status = wxT("s");
+	status = L"s";
 	return 0;
 }
 
 
-
-JobThread::JobThread(const wxString &jid)
-	: wxThread(wxTHREAD_DETACHED)
+JobThread::JobThread(const std::wstring &jid)
+    : m_jobid(jid)
 {
-	LogMessage(wxString::Format(_("Creating job thread for job %s"), jid.c_str()), LOG_DEBUG);
-
-	runnable = false;
-	jobid = jid;
-
-	DBconn *threadConn = DBconn::Get(DBconn::GetBasicConnectString(), serviceDBname);
-	if (threadConn)
-	{
-		job = new Job(threadConn, jobid);
-
-		if (job->Runnable())
-			runnable = true;
-	}
+	LogMessage((L"Creating job thread for job " + m_jobid), LOG_DEBUG);
 }
 
 
 JobThread::~JobThread()
 {
-	LogMessage(wxString::Format(_("Destroying job thread for job %s"), jobid.c_str()), LOG_DEBUG);
-	delete job;
+	LogMessage(L"Destroying job thread for job " + m_jobid, LOG_DEBUG);
 }
 
 
-void *JobThread::Entry()
+void JobThread::operator()()
 {
-	if (runnable)
+	DBconn *threadConn = DBconn::Get(
+		DBconn::GetBasicConnectString(), serviceDBname
+		);
+
+	if (threadConn)
 	{
-		job->Execute();
-	}
+		Job job(threadConn, m_jobid);
 
-	return(NULL);
+		if (job.Runnable())
+		{
+			job.Execute();
+		}
+		else
+		{
+			// Failed to launch the thread. Insert an entry with
+			// "internal error" status in the joblog table, to leave
+			// a trace of fact that we tried to launch the job.
+			DBresultPtr res = threadConn->Execute(
+				L"INSERT INTO pgagent.pga_joblog(jlgid, jlgjobid, jlgstatus) "
+				L"VALUES (nextval('pgagent.pga_joblog_jlgid_seq'), " +
+				m_jobid + L", 'i')"
+				);
+			if (res)
+				res = NULL;
+		}
+	}
 }
diff --git a/misc.cpp b/misc.cpp
index d8508df..2171e82 100644
--- a/misc.cpp
+++ b/misc.cpp
@@ -12,32 +12,33 @@
 #include "pgAgent.h"
 #include "connection.h"
 
-#ifndef __WXMSW__
+#if !BOOST_OS_WINDOWS
 #include <unistd.h>
+#include <stdlib.h>
 #endif
 
-#define APPVERSION_STR wxT(PGAGENT_VERSION)
+#define APPVERSION_STR PGAGENT_VERSION
 
 // In unix.c or win32.c
-void usage(const wxString &executable);
+void usage(const std::wstring &executable);
 
-wxString getArg(int &argc, char **&argv)
+std::wstring getArg(int &argc, char **&argv)
 {
-	wxString s;
+	std::wstring s;
 	if (argv[0][2])
-		s = wxString::FromAscii(argv[0] + 2);
+		s = CharToWString(argv[0] + 2);
 	else
 	{
 		if (argc >= 1)
 		{
 			argc--;
 			argv++;
-			s = wxString::FromAscii(argv[0]);
+			s = CharToWString(argv[0]);
 		}
 		else
 		{
 			// very bad!
-			LogMessage(_("Invalid command line argument"), LOG_ERROR);
+			LogMessage(L"Invalid command line argument", LOG_ERROR);
 		}
 	}
 
@@ -46,11 +47,11 @@ wxString getArg(int &argc, char **&argv)
 
 void printVersion()
 {
-	wxPrintf(_("PostgreSQL Scheduling Agent\n"));
-	wxPrintf(_("Version: %s\n"), APPVERSION_STR);
+	printf("PostgreSQL Scheduling Agent\n");
+	printf("Version: %s\n", APPVERSION_STR);
 }
 
-void setOptions(int argc, char **argv, const wxString &executable)
+void setOptions(int argc, char **argv, const std::wstring &executable)
 {
 	while (argc-- > 0)
 	{
@@ -60,21 +61,21 @@ void setOptions(int argc, char **argv, const wxString &executable)
 			{
 				case 't':
 				{
-					int val = atoi(getArg(argc, argv).mb_str(wxConvUTF8));
+					int val = atoi((const char*)getArg(argc, argv).c_str());
 					if (val > 0)
 						shortWait = val;
 					break;
 				}
 				case 'r':
 				{
-					int val = atoi(getArg(argc, argv).mb_str(wxConvUTF8));
+					int val = atoi((const char*)getArg(argc, argv).c_str());
 					if (val >= 10)
 						longWait = val;
 					break;
 				}
 				case 'l':
 				{
-					int val = atoi(getArg(argc, argv).mb_str(wxConvUTF8));
+					int val = atoi((const char*)getArg(argc, argv).c_str());
 					if (val >= 0 && val <= 2)
 						minLogLevel = val;
 					break;
@@ -82,9 +83,9 @@ void setOptions(int argc, char **argv, const wxString &executable)
 				case 'v':
 				{
 					printVersion();
-					exit (0);
+					exit(0);
 				}
-#ifndef __WXMSW__
+#if !BOOST_OS_WINDOWS
 				case 'f':
 				{
 					runInForeground = true;
@@ -105,9 +106,9 @@ void setOptions(int argc, char **argv, const wxString &executable)
 		}
 		else
 		{
-			if (connectString != wxT(""))
-				connectString += wxT(" ");
-			connectString += wxString::FromAscii(*argv);
+			if (connectString != L"")
+				connectString += L" ";
+			connectString = connectString + CharToWString(*argv);
 			if (**argv == '"')
 				connectString = connectString.substr(1, connectString.length() - 2);
 		}
@@ -135,12 +136,88 @@ void WaitAWhile(const bool waitLong)
 	}
 }
 
+std::wstring NumToStr(const long l)
+{
+	std::wstring buf(boost::lexical_cast<std::wstring>(l));
+	return buf;
+}
 
+// This function is used to convert char* to std::wstring.
+std::wstring CharToWString(const char* cstr)
+{
+	std::string s = std::string(cstr);
+	std::wstring wsTmp(s.begin(), s.end());
+	return wsTmp;
+}
 
-wxString NumToStr(const long l)
+// This function is used to convert std::wstring to char *.
+char * WStringToChar(const std::wstring &wstr)
 {
-	wxString buf;
-	buf.Printf(wxT("%ld"), l);
-	return buf;
+	const wchar_t *wchar_str = wstr.c_str();
+	int wstr_length = wcslen(wchar_str);
+	char *dst = new char[wstr_length + 10];
+	memset(dst, 0x00, (wstr_length + 10));
+	wcstombs(dst, wchar_str, wstr_length);
+	return dst;
 }
 
+// Below function will generate random string of given character.
+std::string generateRandomString(size_t length)
+{
+    srand(time(NULL));
+    char str[length];
+    str[length-1] = '\0';
+    size_t i = 0;
+    int r;
+
+    for(i = 0; i < length-1; ++i)
+    {
+        for(;;)
+        {
+            // interval between 'A' and 'z'
+            r = rand() % 57 + 65;
+            if((r >= 65 && r <= 90) || (r >= 97 && r <= 122))
+            {
+                str[i] = (char)r;
+                break;
+            }
+        }
+    }
+
+    return std::string(str);
+}
+
+std::wstring getTemporaryDirectoryPath()
+{
+
+#if BOOST_OS_WINDOWS
+    std::wstring tmp_dir = L"";
+    wchar_t wcharPath[MAX_PATH];
+    if (GetTempPathW(MAX_PATH, wcharPath))
+        tmp_dir = wcharPath;
+#else
+    // Read this environment variable (TMPDIR, TMP, TEMP, TEMPDIR) and if not found then use "/tmp"
+    std::wstring tmp_dir = L"/tmp";
+    const char *s = getenv("TMPDIR");
+
+    if (s != NULL)
+        tmp_dir = CharToWString(s);
+    else
+    {
+        const char *s1 = getenv("TMP");
+        if (s1 != NULL)
+            tmp_dir = CharToWString(s1);
+        else {
+            const char *s2 = getenv("TEMP");
+            if (s2 != NULL)
+                tmp_dir = CharToWString(s2);
+            else {
+                const char *s3 = getenv("TEMPDIR");
+                if (s3 != NULL)
+                    tmp_dir = CharToWString(s2);
+            }
+        }
+    }
+#endif
+    return tmp_dir;
+}
